using System;
using System.Text.Json.Serialization;

namespace Adaptation.FileHandlers.json.WorkItems;

public class Fields
{
    [JsonConstructor]
    public Fields(
        string systemAreaPath,
        string systemTeamProject,
        string systemIterationPath,
        string systemWorkItemType,
        string systemState,
        string systemReason,
        SystemAssignedTo systemAssignedTo,
        DateTime systemCreatedDate,
        SystemCreatedBy systemCreatedBy,
        DateTime systemChangedDate,
        SystemChangedBy systemChangedBy,
        int systemCommentCount,
        string systemTitle,
        DateTime microsoftVSTSCommonStateChangeDate,
        int microsoftVSTSCommonPriority,
        string systemDescription,
        string systemTags
    )
    {
        SystemAreaPath = systemAreaPath;
        SystemTeamProject = systemTeamProject;
        SystemIterationPath = systemIterationPath;
        SystemWorkItemType = systemWorkItemType;
        SystemState = systemState;
        SystemReason = systemReason;
        SystemAssignedTo = systemAssignedTo;
        SystemCreatedDate = systemCreatedDate;
        SystemCreatedBy = systemCreatedBy;
        SystemChangedDate = systemChangedDate;
        SystemChangedBy = systemChangedBy;
        SystemCommentCount = systemCommentCount;
        SystemTitle = systemTitle;
        MicrosoftVSTSCommonStateChangeDate = microsoftVSTSCommonStateChangeDate;
        MicrosoftVSTSCommonPriority = microsoftVSTSCommonPriority;
        SystemDescription = systemDescription;
        SystemTags = systemTags;
    }

    [JsonPropertyName("System.AreaPath")]
    public string SystemAreaPath { get; } // { init; get; }

    [JsonPropertyName("System.TeamProject")]
    public string SystemTeamProject { get; } // { init; get; }

    [JsonPropertyName("System.IterationPath")]
    public string SystemIterationPath { get; } // { init; get; }

    [JsonPropertyName("System.WorkItemType")]
    public string SystemWorkItemType { get; } // { init; get; }

    [JsonPropertyName("System.State")]
    public string SystemState { get; } // { init; get; }

    [JsonPropertyName("System.Reason")]
    public string SystemReason { get; } // { init; get; }

    [JsonPropertyName("System.AssignedTo")]
    public SystemAssignedTo SystemAssignedTo { get; } // { init; get; }

    [JsonPropertyName("System.CreatedDate")]
    public DateTime SystemCreatedDate { get; } // { init; get; }

    [JsonPropertyName("System.CreatedBy")]
    public SystemCreatedBy SystemCreatedBy { get; } // { init; get; }

    [JsonPropertyName("System.ChangedDate")]
    public DateTime SystemChangedDate { get; } // { init; get; }

    [JsonPropertyName("System.ChangedBy")]
    public SystemChangedBy SystemChangedBy { get; } // { init; get; }

    [JsonPropertyName("System.CommentCount")]
    public int SystemCommentCount { get; } // { init; get; }

    [JsonPropertyName("System.Title")]
    public string SystemTitle { get; } // { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Common.StateChangeDate")]
    public DateTime MicrosoftVSTSCommonStateChangeDate { get; } // { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Common.Priority")]
    public int MicrosoftVSTSCommonPriority { get; } // { init; get; }

    [JsonPropertyName("System.Description")]
    public string SystemDescription { get; } // { init; get; }

    [JsonPropertyName("System.Tags")]
    public string SystemTags { get; } // { init; get; }
}